#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight24004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight24004xi = {
                1:'-1020x-579y-2093z',
                2:'-1022x-2166y-143z',
                3:'-1040x-1448y-1605z',
                4:'-1060x-1673y-1354z',
                5:'-1068x-534y-2081z',
                6:'-1113x-486y-2069z',
                7:'-1125x-1404y-1587z',
                8:'-1134x-2111y-119z',
                9:'-1153x-1626y-1334z',
                10:'-1157x-434y-2057z',
                11:'-1197x-379y-2044z',
                12:'-1207x-1355y-1569z',
                13:'-122x-431y-2357z',
                14:'-1235x-321y-2032z',
                15:'-1244x-2050y-95z',
                16:'-1245x-1574y-1314z',
                17:'-1288x-1301y-1551z',
                18:'-131x-791y-2261z',
                19:'-1335x-1516y-1294z',
                20:'-1350x-1982y-71z',
                21:'-1365x-1242y-1532z',
                22:'-1421x-1454y-1274z',
                23:'-1440x-1179y-1514z',
                24:'-1452x-1909y-47z',
                25:'-1505x-1386y-1254z',
                26:'-1512x-1111y-1495z',
                27:'-152x-446y-2353z',
                28:'-1550x-1831y-23z',
                29:'-1581x-1038y-1476z',
                30:'-1585x-1313y-1233z',
                31:'-160x-1606y-1775z',
                32:'-1644x-1747y0z',
                33:'-1646x-961y-1457z',
                34:'-1661x-1236y-1212z',
                35:'-1707x-881y-1438z',
                36:'-172x-1843y-1527z',
                37:'-1733x-1154y-1192z',
                38:'-1763x-796y-1419z',
                39:'-176x-2373y-310z',
                40:'-177x-805y-2253z',
                41:'-1802x-1067y-1171z',
                42:'-1816x-708y-1399z',
                43:'-184x-459y-2348z',
                44:'-1864x-616y-1380z',
                45:'-1865x-977y-1150z',
                46:'-1906x-521y-1360z',
                47:'-1924x-883y-1129z',
                48:'-1944x-424y-1340z',
                49:'-1977x-323y-1320z',
                50:'-1978x-785y-1107z',
                51:'-2004x-221y-1300z',
                52:'-2027x-684y-1086z',
                53:'-2070x-580y-1065z',
                54:'-2108x-473y-1043z',
                55:'-218x-470y-2343z',
                56:'-225x-817y-2245z',
                57:'-23x-353y-2373z',
                58:'-246x-1613y-1759z',
                59:'-253x-479y-2337z',
                60:'-271x-1846y-1508z',
                61:'-274x-825y-2236z',
                62:'-290x-485y-2332z',
                63:'-301x-2363y-286z',
                64:'-325x-830y-2227z',
                65:'-328x-489y-2326z',
                66:'-334x-1615y-1742z',
                67:'-367x-489y-2320z',
                68:'-370x-1844y-1490z',
                69:'-378x-832y-2218z',
                70:'-407x-487y-2314z',
                71:'-423x-1612y-1726z',
                72:'-424x-2347y-263z',
                73:'-431x-831y-2209z',
                74:'-448x-482y-2307z',
                75:'-45x-374y-2370z',
                76:'-469x-1837y-1471z',
                77:'-485x-826y-2200z',
                78:'-489x-474y-2301z',
                79:'-4x-330y-2377z',
                80:'-512x-1604y-1709z',
                81:'-52x-2375y-334z',
                82:'-530x-463y-2294z',
                83:'-540x-818y-2190z',
                84:'-547x-2324y-239z',
                85:'-569x-1823y-1452z',
                86:'-572x-449y-2287z',
                87:'-595x-806y-2180z',
                88:'-601x-1591y-1692z',
                89:'-613x-431y-2279z',
                90:'-650x-791y-2170z',
                91:'-654x-411y-2272z',
                92:'-669x-1805y-1432z',
                93:'-669x-2294y-215z',
                94:'-68x-395y-2366z',
                95:'-690x-1573y-1675z',
                96:'-695x-387y-2264z',
                97:'-705x-772y-2160z',
                98:'-734x-360y-2256z',
                99:'-75x-1595y-1791z',
                100:'-75x-1834y-1545z',
                101:'-760x-749y-2149z',
                102:'-768x-1780y-1413z',
                103:'-773x-330y-2247z',
                104:'-779x-1549y-1658z',
                105:'-789x-2258y-191z',
                106:'-810x-297y-2239z',
                107:'-814x-722y-2138z',
                108:'-846x-260y-2230z',
                109:'-867x-1521y-1640z',
                110:'-867x-1750y-1394z',
                111:'-867x-692y-2127z',
                112:'-880x-221y-2221z',
                113:'-906x-2215y-167z',
                114:'-90x-807y-2364z',
                115:'-912x-179y-2212z',
                116:'-920x-658y-2116z',
                117:'-942x-134y-2203z',
                118:'-94x-414y-2362z',
                119:'-955x-1487y-1623z',
                120:'-964x-1714y-1374z',
                121:'-970x-87y-2193z',
                122:'-971x-620y-2105z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400eight4xi" usage = "target function for charge2400eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2400eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight24004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight24004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2400EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  